package com.example.demo_fingerprint_morpho.fragment;

import android.app.ProgressDialog;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;


import com.example.demo_fingerprint_morpho.MainActivity;
import com.example.demo_fingerprint_morpho.R;
import com.rscja.deviceapi.FingerprintWithMorpho;

public class IdentificationFragment extends KeyDwonFragment {
	private MainActivity mContext;
	private static final String TAG = "FingerprintWithMorpho11";
	Button btnIdent;
	TextView tvInfo;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		Log.i(TAG, "onCreateView()");
		View v = inflater.inflate(R.layout.fingerprint_identification_fragment,
				container, false);
		return v;
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		mContext = (MainActivity) getActivity();
		init();
	}
	@Override
	public void onPause() {
		Log.d(TAG,"onPause");
		// TODO Auto-generated method stub
		super.onPause();
		tvInfo.setText("");
		stop();
	}

	@Override
	public void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		Log.d(TAG,"onResume");
	}
	private void init() {
		mContext.mFingerprint.setIdentificationCallBack(new IdentificationCallBack());
		btnIdent = (Button) getView().findViewById(R.id.btnIdent);
		tvInfo = (TextView) getView().findViewById(R.id.tvInfo);
		btnIdent.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				tvInfo.setText("Processing, please keep finger on the sensor!");
				mContext.mFingerprint.startIdentification();
				start();
			}
		});

	}

   private  class  IdentificationCallBack  implements FingerprintWithMorpho.IdentificationCallBack {
	   @Override
	   public void messageInfo(String s,int code) {
		   tvInfo.setText(s+"(code:"+code+")");
		   setMeg(s);
	   }

	   @Override
	   public void onComplete(boolean b, int i, String s, int i1) {
		   if(b) {
			   tvInfo.append("\nID:"+i);
			   tvInfo.append("\nname:"+s);
			   mContext.playSound(1);
		   }else{
			   mContext.playSound(2);
		   }
		   stop();
	   }
   }

	void start(){
		showProgressDialog();
	}
	void stop(){
		if(mypDialog!=null)
			mypDialog.dismiss();
	}

	ProgressDialog mypDialog=null;
	public void showProgressDialog() {
		if(mypDialog==null) {
			mypDialog = new ProgressDialog(mContext);
		}
		mypDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		mypDialog.setMessage("wait...");
		mypDialog.setCancelable(false);
		mypDialog.setCanceledOnTouchOutside(false);
		mypDialog.show();
	}
	public  void setMeg(String msg){
		if(mypDialog!=null)
			mypDialog.setMessage(msg);
	}
}
